Bug 479799 - Review Request: ghc-uniplate - Uniform type generic traversals
Review Request: ghc-uniplate - Uniform type generic traversals
Status: CLOSED RAWHIDE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Yaakov Nemoy
Fedora Extras Quality Assurance
:
Depends On:
Blocks: hlint
  Show dependency treegraph
 
Reported: 2009-01-13 00:56 EST by Conrad Meyer
Modified: 2014-01-02 00:51 EST (History)
5 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-03-22 17:53:59 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
loupgaroublond: fedora‑review+
petersen: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Conrad Meyer 2009-01-13 00:56:16 EST
Spec URL: http://konradm.fedorapeople.org/fedora/SPECS/ghc-uniplate.spec
SRPM URL: http://konradm.fedorapeople.org/fedora/SRPMS/ghc-uniplate-1.2.0.3-1.fc9.src.rpm
Description:
Uniplate is a boilerplate removal library, with similar goals to the
original Scrap Your Boilerplate work. It requires few extensions to
Haskell.

Koji build:
http://koji.fedoraproject.org/koji/taskinfo?taskID=1048735
Comment 1 Jens Petersen 2009-03-09 21:25:47 EDT
ping :)
Comment 2 Jason Tibbitts 2009-03-13 02:10:00 EDT
Who is Jens pinging?
Comment 3 Conrad Meyer 2009-03-13 02:15:30 EDT
Me, I think -- I think I need to update to the new Haskell templates.
Comment 5 Yaakov Nemoy 2009-03-20 19:38:26 EDT
I'll take this review.

Looking at the spec file briefly, i can see several things

* The URL should probably point to the project's homepage rather than the hackage page. See the bug for hscolour for more reasoning

Otherwise, we look good here.  Following the review guidelines:

#  MUST: rpmlint must be run on every package. The output should be posted in the review.[1]

ghc-uniplate-prof.x86_64: W: no-documentation
ghc-uniplate-prof.x86_64: W: devel-file-in-non-devel-package /usr/lib64/ghc-6.10.1/uniplate-1.2.0.3/libHSuniplate-1.2.0.3_p.a
ghc-uniplate-prof.x86_64: E: devel-dependency ghc-uniplate-devel
4 packages and 0 specfiles checked; 1 errors, 2 warnings.

PASS

# MUST: The package must be named according to the Package Naming Guidelines .

PASS

# MUST: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption. [2] .

PASS

# MUST: The package must meet the Packaging Guidelines .

PASS

# MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines .

PASS

# MUST: The License field in the package spec file must match the actual license. [3]

PASS

# MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.[4]

PASS

# MUST: The spec file must be written in American English. [5]

PASS

# MUST: The spec file for the package MUST be legible. [6]

PASS

# MUST: The sources used to build the package must match the upstream source, as provided in the spec URL. Reviewers should use md5sum for this task. If no upstream URL can be specified for this package, please see the Source URL Guidelines for how to deal with this.

PASS

# MUST: The package MUST successfully compile and build into binary rpms on at least one primary architecture. [7]

PASS

# MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in bugzilla, describing the reason that the package does not compile/build/work on that architecture. The bug number MUST be placed in a comment, next to the corresponding ExcludeArch line. [8]

PASS (misses PPC64 which is allowed for Haskell packages using GHC.)

# MUST: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional. Apply common sense.

PASS

# MUST: The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.[9]

N/A

# MUST: Every binary RPM package (or subpackage) which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun. [10]

N/A

# MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package. Without this, use of Prefix: /usr is considered a blocker. [11]

N/A

# MUST: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory. [12]

PASS

# MUST: A Fedora package must not list a file more than once in the spec file's %files listings. [13]

PASS

# MUST: Permissions on files must be set properly. Executables should be set with executable permissions, for example. Every %files section must include a %defattr(...) line. [14]

PASS

# MUST: Each package must have a %clean section, which contains rm -rf %{buildroot} (or $RPM_BUILD_ROOT). [15]

PASS

# MUST: Each package must consistently use macros. [16]

PASS

# MUST: The package must contain code, or permissable content. [17]

PASS

# MUST: Large documentation files must go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity). [18]

PASS

# MUST: If a package includes something as %doc, it must not affect the runtime of the application. To summarize: If it is in %doc, the program must run properly if it is not present. [18]

PASS

# MUST: Header files must be in a -devel package. [19]

PASS

# MUST: Static libraries must be in a -static package. [20]

N/A

# MUST: Packages containing pkgconfig(.pc) files must 'Requires: pkgconfig' (for directory ownership and usability). [21]

N/A

# MUST: If a package contains library files with a suffix (e.g. libfoo.so.1.1), then library files that end in .so (without suffix) must go in a -devel package. [19]

N/A

# MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name} = %{version}-%{release} [22]

N/A (excepted because Haskell does not do shared libraries)

# MUST: Packages must NOT contain any .la libtool archives, these must be removed in the spec if they are built.[20]

PASS

# MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section. If you feel that your packaged GUI application does not need a .desktop file, you must put a comment in the spec file with your explanation. [23]

N/A

# MUST: Packages must not own files or directories already owned by other packages. The rule of thumb here is that the first package to be installed should own the files or directories that other packages may rely upon. This means, for example, that no package in Fedora should ever share ownership with any of the files or directories owned by the filesystem or man package. If you feel that you have a good reason to own a file or directory that another package owns, then please present that at package review time. [24]

N/A

# MUST: At the beginning of %install, each package MUST run rm -rf %{buildroot} (or $RPM_BUILD_ROOT). [25]

N/A

# MUST: All filenames in rpm packages must be valid UTF-8. [26]

PASS

* SHOULD: If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it. [27]

N/A

* SHOULD: The description and summary sections in the package spec file should contain translations for supported Non-English languages, if available. [28]

N/A

* SHOULD: The reviewer should test that the package builds in mock. [29]

PASS (x86_64)

* SHOULD: The package should compile and build into binary rpms on all supported architectures. [30]

Not Done, lack of PPC architecture.

* SHOULD: The reviewer should test that the package functions as described. A package should not segfault instead of running, for example.

No Tests included with package. Please convince upstream to write unit tests, kthxbye. N/A

* SHOULD: If scriptlets are used, those scriptlets must be sane. This is vague, and left up to the reviewers judgement to determine sanity. [31]

PASS

* SHOULD: Usually, subpackages other than devel should require the base package using a fully versioned dependency. [22]

PASS

* SHOULD: The placement of pkgconfig(.pc) files depends on their usecase, and this is usually for development purposes, so should be placed in a -devel pkg. A reasonable exception is that the main pkg itself is a devel tool not installed in a user runtime, e.g. gcc or gdb. [21]

N/A

* SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the file instead of the file itself. [32] 

N/A

In short, fix the URL, and i can approve this.
Comment 7 Yaakov Nemoy 2009-03-20 19:55:15 EDT
Looks good. APPROVED
Comment 8 Conrad Meyer 2009-03-20 19:57:17 EDT
New Package CVS Request
=======================
Package Name: ghc-uniplate
Short Description: Uniform type generic traversals
Owners: konradm
Branches: F-10
InitialCC:
Comment 9 Kevin Fenzi 2009-03-22 01:40:26 EDT
cvs done.
Comment 10 Conrad Meyer 2009-03-22 17:53:59 EDT
Built in rawhide.
http://koji.fedoraproject.org/koji/taskinfo?taskID=1253377
Comment 11 Jens Petersen 2013-12-27 01:30:56 EST
Package Change Request
======================
Package Name: ghc-uniplate
New Branches: el6
Owners: petersen
InitialCC: haskell-sig
Comment 12 Jens Petersen 2014-01-02 00:51:46 EST
Git done (by process-git-requests).

Note You need to log in before you can comment on or make changes to this bug.